/*
TASK:burn
LANG:C++
*/

#include <iostream>
#include <fstream>
#include <iomanip>
using namespace std;
#define maxN 200
#define maxM 6000
#define maxINT 10000000
typedef struct Link { int x,y,l; };

int N,M,D[maxN+1];
float F[maxN+1][maxN+1],T[maxM+1];
Link P[maxM+1];

void init();
void solve();
void calc(int v);

int main()
{
 init();
 solve();
 return 0;
}

void init()
{
 int i,j,x,y;
 for (i=1;i<=maxN;i++)
    for (j=1;j<=maxN;j++)
       if (i!=j) F[i][j]=maxINT;
// ifstream fin("burn.in");
 cin>>N>>M;
 for (i=1;i<=M;i++) {
    cin>>x>>y>>j;
    P[i].x=x;P[i].y=y;P[i].l=j;
    if (j<F[x+N][y]) F[x+N][y]=j;
    if (j<F[y+N][x]) F[y+N][x]=j;
    D[x]++;D[y]++; }
 for (i=1;i<=N;i++) F[i][i+N]=D[i];
// fin.close();
}

void solve()
{
 int i,j,k;
 double res,sum=maxINT;
 for (k=1;k<=2*N;k++)
    for (i=1;i<=2*N;i++)
       for (j=1;j<=2*N;j++)
          if (F[i][k]+F[k][j]<F[i][j])
             F[i][j]=F[i][k]+F[k][j];
 for (i=1;i<=N;i++) {
    calc(i);
    for (res=0,j=N+1;j<=2*N;j++)
       if (F[i][j]>res) res=F[i][j];
    for (j=1;j<=M;j++)
       if (T[j]>res) res=T[j];
    if (res<sum) sum=res; }
 cout<<setiosflags(ios::fixed)<<setprecision(1)<<sum<<endl;
}

void calc(int v)
{
 double t1,t2,raz;
 for (int i=1;i<=M;i++) {
    t1=F[v][P[i].x+N];
    t2=F[v][P[i].y+N];
    if (t1>t2) swap(t1,t2);
    raz=t2-t1;
    if (P[i].l<=raz) T[i]=t1+P[i].l;
       else T[i]=t1+raz+(double)(P[i].l-raz)/2; }
}
