/*
TASK:treas
LANG:C++
*/

#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <ctime>
using namespace std;

struct TGold {
       int x,  y;
       int p;
       int ID;
}Gold[1024];
     
int N;
int minx, maxx;
int S[10001];
int A[10001];
int SortP[1024];

bool cmp(TGold a, TGold b) {
     if(a.y!=b.y) return a.y<b.y;
     else return a.x<b.x;
}

bool cmp1(int a, int b) {
     return Gold[a].p>Gold[b].p;
}
     
int Find(int x, int y) {
    int l,r,m;
    l = 0;
    r = N-1;
    if(Gold[0].y==y && Gold[0].x>=x) return 0;
    while(l<=r)
    {
              m = (l+r)/2;
              
              if(Gold[m].y<y) l=m+1;
              else if(Gold[m].y>y) r=m-1;
              else
              {
                  if(Gold[m].x<x) l=m+1;
                  else if(Gold[m].x>=x && (Gold[m-1].x<x || Gold[m-1].y!=y)) break;
                  else if(Gold[m].x>x) r=m-1;
              }
    }
    if(l>r) return -1;
    return m;
}
    
int Calc(int g){
    int R = 0;
    int x1=Gold[g].x-1;
    int x2=Gold[g].x+1;
    int y=Gold[g].y+1;
    int g1;
    R = Gold[g].p-S[-Gold[g].y];
    while(y<=-1)
    {
           g1 = Find(x1,y);
           if(g1!=-1)
           {
                 while(g1<N && Gold[g1].y==y && Gold[g1].x<=x2) R+=Gold[g1++].p;    
           }
           y++;
           x1--;
           x2++;
           
    } 
    return R;
}

     
void Init(void) {
     int x,y,p,i;
     maxx = -110000;
     minx = 11000;
     scanf("%d",&N);
        for(i=0; i<N; i++) { scanf("%d%d%d",&(Gold[i].x),&(Gold[i].y),&(Gold[i].p)); Gold[i].ID=i; if(Gold[i].x>maxx) maxx=Gold[i].x;  if(Gold[i].x<minx) minx=Gold[i].x; }
     sort(Gold,Gold+N,cmp);
    // for(i=0; i<N; i++) printf("%d %d %d\n",Gold[i].x,Gold[i].y,Gold[i].p);
     A[1] = 1;
     for(i=2; i<=10000; i++) A[i]=A[i-1]+2;
     S[0] = 0;
     for(i=1; i<=10000; i++) { S[i] = S[i-1]+A[i]; /*printf("S[%d]=%d\n",i,S[i]);*/ }
     for(i=0; i<N; i++) SortP[i]=i;
     sort(SortP,SortP+N,cmp1);
}

void Solve(void) {
     int i,x;
     int Max = 0;
     for(i=0; i<N; i++)
     {
              
              x = SortP[i];
               int T = Calc(x);
               if(T>Max) Max = T;             
               if((double)clock()/(double)CLOCKS_PER_SEC>=0.4) break;
     }
     printf("%d\n",Max);
}
     
int main(void) {
    clock();
/*    printf("0 2 3 2\n");
    printf("1 2 1 4\n");
    printf("1 3 3 3\n");
    printf("2 0 2 2\n");
    printf("0 1 2 1\n");
    printf("2 2 2 3\n");*/
    Init();
    Solve();
//    printf("%d\n",Find(9,-10));
        return 0;
}
